diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
new file mode 100644
index 000000000..be264996d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
@@ -0,0 +1,178 @@
+package net.minecraft.core.world.biome.provider;
+
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.noise.PerlinSimplexNoise;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Arrays;
+import java.util.Random;
+
+public class BiomeProviderB173
+    extends BiomeProvider
+{
+    private static final float ZOOM = 2.0f;
+    private static final float TEMP_SCALE = 0.025F;
+    private static final float DOWNFALL_SCALE = 0.05F;
+    private static final float NOISE_SCALE = 0.25F;
+
+    private final @NotNull PerlinSimplexNoise temperatureMap;
+    private final @NotNull PerlinSimplexNoise downfallMap;
+    private final @NotNull PerlinSimplexNoise noiseMap;
+
+    public BiomeProviderB173(final long seed) {
+        this.temperatureMap = new PerlinSimplexNoise(new Random(seed * 9871L), 4);
+        this.downfallMap = new PerlinSimplexNoise(new Random(seed * 39811L), 4);
+        this.noiseMap = new PerlinSimplexNoise(new Random(seed * 543321L), 2);
+    }
+
+    @Override
+    public Biome[] getBiomes(Biome[] biomes, double[] temperatures, double[] humidities, double[] varieties, final int x, final int y, final int z, final int xSize, final int ySize, final int zSize) {
+        if (biomes == null || biomes.length < xSize * ySize * zSize) {
+            biomes = new Biome[xSize * ySize * zSize];
+        }
+
+        if (temperatures == null || temperatures.length < xSize * zSize) {
+            temperatures = new double[xSize * zSize];
+        }
+        this.temperatureMap.getValue(temperatures, x, z, xSize, xSize, 0.025, 0.025, 0.25);
+
+        if (humidities == null || humidities.length < xSize * zSize) {
+            humidities = new double[xSize * zSize];
+        }
+        this.downfallMap.getValue(humidities, x, z, xSize, xSize, 0.05, 0.05, 1.0 / 3.0);
+
+        if (varieties == null || varieties.length < xSize * zSize) {
+            varieties = new double[xSize * zSize];
+        }
+        Arrays.fill(varieties, 0.0);
+
+        final double[] noises = this.noiseMap.getValue(null, x, z, xSize, xSize, 0.25, 0.25, 0.5882352941176471D);
+
+        for (int xx = 0; xx < xSize; xx++) {
+            for (int zz = 0; zz < zSize; zz++) {
+                final double a = noises[xx * zSize + zz] * 1.1 + 0.5;
+                double b = 0.01;
+                double c = 1.0 - b;
+                double temperature = (temperatures[xx * zSize + zz] * 0.15 + 0.7) * c + a * b;
+
+                b = 0.002;
+                c = 1.0 - b;
+                double downfall = (humidities[xx * zSize + zz] * 0.15 + 0.5) * c + a * b;
+
+                temperature = 1.0 - (1.0 - temperature) * (1.0 - temperature);
+
+                if (temperature < 0.0) {
+                    temperature = 0.0;
+                }
+                if (temperature > 1.0) {
+                    temperature = 1.0;
+                }
+
+                if (downfall < 0.0) {
+                    downfall = 0.0;
+                }
+                if (downfall > 1.0) {
+                    downfall = 1.0;
+                }
+
+                temperatures[xx * zSize + zz] = temperature;
+                humidities[xx * zSize + zz] = downfall;
+
+                for (int yy = 0; yy < ySize; yy++) {
+                    biomes[yy * xSize * zSize + zz * xSize + xx] = this.lookupBiome(temperature, downfall, 0.0, 0.0);
+                }
+            }
+        }
+
+        return biomes;
+    }
+
+    @Override
+    public double[] getTemperatures(double[] temperatures, final int x, final int z, final int xSize, final int zSize) {
+        if (temperatures == null || temperatures.length < xSize * zSize) {
+            temperatures = new double[xSize * zSize];
+        }
+
+        this.temperatureMap.getValue(temperatures, x, z, xSize, xSize, 0.025, 0.025, 0.25);
+        final double[] noises = this.noiseMap.getValue(null, x, z, xSize, zSize, 0.25, 0.25, 0.5882352941176471D);
+
+        int i = 0;
+        for (int xx = 0; xx < xSize; xx++) {
+            for (int zz = 0; zz < zSize; zz++) {
+                final double a = noises[i] * 1.1 + 0.5;
+                final double b = 0.01;
+                final double c = 1.0 - b;
+                double temperature = (temperatures[i] * 0.15 + 0.7) * c + a * b;
+                temperature = 1.0 - (1.0 - temperature) * (1.0 - temperature);
+
+                if (temperature < 0.0) {
+                    temperature = 0.0;
+                }
+                if (temperature > 1.0) {
+                    temperature = 1.0;
+                }
+
+                temperatures[i++] = temperature;
+            }
+        }
+
+        return temperatures;
+    }
+
+    @Override
+    public double[] getHumidities(double[] humidities, final int x, final int z, final int xSize, final int zSize) {
+        if (humidities == null || humidities.length < xSize * zSize) {
+            humidities = new double[xSize * zSize];
+        }
+
+        return this.downfallMap.getValue(humidities, x, z, xSize, zSize, 0.05, 0.05, 0.5);
+    }
+
+    @Override
+    public double[] getVarieties(double[] varieties, final int x, final int z, final int xSize, final int zSize) {
+        if (varieties == null || varieties.length < xSize * zSize) {
+            varieties = new double[xSize * zSize];
+        }
+
+        Arrays.fill(varieties, 0.0);
+
+        return varieties;
+    }
+
+    @Override
+    public double[] getBiomenesses(double[] biomenesses, final int x, final int y, final int z, final int xSize, final int ySize, final int zSize) {
+        if (biomenesses == null || biomenesses.length < xSize * ySize * zSize) {
+            biomenesses = new double[xSize * ySize * zSize];
+        }
+
+        Arrays.fill(biomenesses, 1.0);
+
+        return biomenesses;
+    }
+
+    @Override
+    public Biome lookupBiome(final double temperature, double humidity, final double altitude, final double variety) {
+        humidity *= temperature;
+
+        if (temperature < 0.1) {
+            return Biomes.OVERWORLD_LEGACY_TUNDRA;
+        } else if (humidity < 0.2) {
+            if (temperature < 0.5) {
+                return Biomes.OVERWORLD_LEGACY_TUNDRA;
+            } else {
+                return temperature < 0.95 ? Biomes.OVERWORLD_LEGACY_SAVANNA : Biomes.OVERWORLD_LEGACY_DESERT;
+            }
+        } else if (humidity > 0.5 && temperature < 0.7) {
+            return Biomes.OVERWORLD_LEGACY_SWAMPLAND;
+        } else if (temperature < 0.5) {
+            return Biomes.OVERWORLD_LEGACY_TAIGA;
+        } else if (temperature < 0.97) {
+            return humidity < 0.35 ? Biomes.OVERWORLD_LEGACY_SHRUBLAND : Biomes.OVERWORLD_LEGACY_FOREST;
+        } else if (humidity < 0.45) {
+            return Biomes.OVERWORLD_LEGACY_PLAINS;
+        } else {
+            return humidity < 0.9 ? Biomes.OVERWORLD_LEGACY_SEASONAL_FOREST : Biomes.OVERWORLD_LEGACY_RAINFOREST;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
index db17755be..9635a88d9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -55,16 +55,19 @@ public final class BiomeProviderNether
         }
         if (temperatures == null || temperatures.length < xSize * zSize)
         {
-            temperatures = getTemperatures(temperatures, x, z, xSize, zSize);
+            temperatures = new double[xSize * zSize];
         }
+        getTemperatures(temperatures, x, z, xSize, zSize);
         if (humidities == null || humidities.length < xSize * zSize)
         {
-            humidities = getHumidities(humidities, x, z, xSize, zSize);
+            humidities = new double[xSize * zSize];
         }
+        getHumidities(humidities, x, z, xSize, zSize);
         if (varieties == null || varieties.length < xSize * zSize)
         {
-            varieties = getVarieties(varieties, x, z, xSize, zSize);
+            varieties = new double[xSize * zSize];
         }
+        getVarieties(varieties, x, z, xSize, zSize);
 
         for (int dx = 0; dx < xSize; dx++)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index 61c5dc3a1..8affa5997 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -91,16 +91,19 @@ public final class BiomeProviderOverworld
         }
         if (temperatures == null || temperatures.length < xSize * zSize)
         {
-            temperatures = getTemperatures(temperatures, x, z, xSize, zSize);
+            temperatures = new double[xSize * zSize];
         }
+        getTemperatures(temperatures, x, z, xSize, zSize);
         if (humidities == null || humidities.length < xSize * zSize)
         {
-            humidities = getHumidities(humidities, x, z, xSize, zSize);
+            humidities = new double[xSize * zSize];
         }
+        getHumidities(humidities, x, z, xSize, zSize);
         if (varieties == null || varieties.length < xSize * zSize)
         {
-            varieties = getVarieties(varieties, x, z, xSize, zSize);
+            varieties = new double[xSize * zSize];
         }
+        getVarieties(varieties, x, z, xSize, zSize);
 
         for (int dx = 0; dx < xSize; dx++)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
new file mode 100644
index 000000000..90928c9f6
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
@@ -0,0 +1,239 @@
+package net.minecraft.core.world.generate;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkSection;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+
+import java.util.Random;
+
+public class RetroCavesLargeFeature extends LargeFeature {
+    private Random rand;
+    private final int minY;
+    private final int maxY;
+
+    public RetroCavesLargeFeature() {
+        this(0, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y);
+    }
+
+    public RetroCavesLargeFeature(int minY, int maxY) {
+        this.minY = minY;
+        this.maxY = maxY;
+        this.rand = new Random();
+    }
+
+    @Override
+    public void generate(World world, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result)
+    {
+        int radius = radiusChunk;
+        rand.setSeed(world.getRandomSeed());
+        worldObj = world;
+        long randX = (this.rand.nextLong() / 2L) * 2L + 1L;
+        long randZ = (this.rand.nextLong() / 2L) * 2L + 1L;
+        for(int chunkX = baseChunkX - radius; chunkX <= baseChunkX + radius; chunkX++)
+        {
+            for(int chunkZ = baseChunkZ - radius; chunkZ <= baseChunkZ + radius; chunkZ++)
+            {
+                this.rand.setSeed((long)chunkX * randX + (long)chunkZ * randZ ^ world.getRandomSeed());
+                doGeneration(world, chunkX, chunkZ, baseChunkX, baseChunkZ, result);
+            }
+
+        }
+    }
+
+    protected void generateHubRoom(int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
+        generateCave(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + this.rand.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
+    }
+
+    protected void generateCave(int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY,
+                                double blockZ, float initialRadius, float yRot, float xRot, int startPos, int endPos,
+                                double heightMod) {
+        double chunkMiddleX = baseChunkX * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X / 2;
+        double chunkMiddleZ = baseChunkZ * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z / 2;
+        float rotHorOffset = 0.0F;
+        float rotVerOffset = 0.0F;
+        Random random = new Random(this.rand.nextLong());
+        if (endPos <= 0) {
+            int maxLength = radiusChunk * 16 - 16;
+            endPos = maxLength - random.nextInt(maxLength / 4);
+        }
+        boolean noBranches = false;
+        if (startPos == -1) {
+            startPos = endPos / 2;
+            noBranches = true;
+        }
+        int branchPos = random.nextInt(endPos / 2) + endPos / 4;
+        boolean sharpRotVer = random.nextInt(6) == 0;
+        for (; startPos < endPos; startPos++) {
+            double width = 1.5D + (MathHelper.sin((startPos * MathHelper.PI) / endPos) * initialRadius * 1.0F);
+            double height = width * heightMod;
+            float xzScale = MathHelper.cos(xRot);
+            float yOffset = MathHelper.sin(xRot);
+            blockX += MathHelper.cos(yRot) * xzScale;
+            blockY += yOffset;
+            blockZ += MathHelper.sin(yRot) * xzScale;
+            if (sharpRotVer) {
+                xRot *= 0.92F;
+            } else {
+                xRot *= 0.7F;
+            }
+            xRot += rotVerOffset * 0.1F;
+            yRot += rotHorOffset * 0.1F;
+            rotVerOffset *= 0.9F;
+            rotHorOffset *= 0.75F;
+            rotVerOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 2.0F;
+            rotHorOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 4F;
+
+            // Do adjacent branches if necessary
+            if (!noBranches && startPos == branchPos && initialRadius > 1.0F) {
+                generateCave(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                generateCave(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                return;
+            }
+
+            // Randomly skip a section
+            if (!noBranches && random.nextInt(4) == 0) {
+                continue;
+            }
+
+            // Check if we've gone far enough, and stop if so
+            double dxFromMiddle = blockX - chunkMiddleX;
+            double dzFromMiddle = blockZ - chunkMiddleZ;
+            double length = endPos - startPos;
+            double maxRadius = initialRadius + 2.0F + 16F;
+            if ((dxFromMiddle * dxFromMiddle + dzFromMiddle * dzFromMiddle) - length * length > maxRadius * maxRadius) {
+                return;
+            }
+            if (blockX < chunkMiddleX - Chunk.CHUNK_SIZE_X - width * 2D || blockZ < chunkMiddleZ - Chunk.CHUNK_SIZE_Z - width * 2D || blockX > chunkMiddleX + Chunk.CHUNK_SIZE_X + width * 2D || blockZ > chunkMiddleZ + Chunk.CHUNK_SIZE_Z + width * 2D) {
+                continue;
+            }
+
+            // Determine sizes of current section
+            int minX = MathHelper.floor(blockX - width) - baseChunkX * Chunk.CHUNK_SIZE_X - 1;
+            int maxX = (MathHelper.floor(blockX + width) - baseChunkX * Chunk.CHUNK_SIZE_X) + 1;
+            int minY = MathHelper.floor(blockY - height) - 1;
+            int maxY = MathHelper.floor(blockY + height) + 1;
+            int minZ = MathHelper.floor(blockZ - width) - baseChunkZ * Chunk.CHUNK_SIZE_Z - 1;
+            int maxZ = (MathHelper.floor(blockZ + width) - baseChunkZ * Chunk.CHUNK_SIZE_Z) + 1;
+            if (minX < 0) {
+                minX = 0;
+            }
+            if (maxX > Chunk.CHUNK_SIZE_X) {
+                maxX = Chunk.CHUNK_SIZE_X;
+            }
+            if (minY < this.minY + 1) {
+                minY = this.minY + 1;
+            }
+            if (maxY > this.maxY - (ChunkSection.SECTION_SIZE_Y / 2)) {
+                maxY = this.maxY - (ChunkSection.SECTION_SIZE_Y / 2);
+            }
+            if (minZ < 0) {
+                minZ = 0;
+            }
+            if (maxZ > Chunk.CHUNK_SIZE_Z) {
+                maxZ = Chunk.CHUNK_SIZE_Z;
+            }
+
+            // Check if we've hit the ocean, and if so, stop generating
+            if (worldObj.getWorldType().getOceanBlockId() != 0) {
+                boolean hasHitOcean = false;
+                for (int x = minX; !hasHitOcean && x < maxX; x++) {
+                    for (int z = minZ; !hasHitOcean && z < maxZ; z++) {
+                        for (int y = maxY + 1; !hasHitOcean && y >= minY - 1; y--) {
+                            int blockId = result.getBlock(x, y, z);
+
+                            if (y < this.minY || y >= this.maxY) {
+                                continue;
+                            }
+                            if (blockId == worldObj.getWorldType().getOceanBlockId()) {
+                                hasHitOcean = true;
+                            }
+                            if (y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1) {
+                                y = minY;
+                            }
+                        }
+                    }
+                }
+                if (hasHitOcean) {
+                    continue;
+                }
+            }
+
+            // Delete blocks in section
+            for (int x = minX; x < maxX; x++) {
+                double xPercentage = (((x + baseChunkX * Chunk.CHUNK_SIZE_X) + 0.5D) - blockX) / width;
+                for (int z = minZ; z < maxZ; z++) {
+                    double zPercentage = (((z + baseChunkZ * Chunk.CHUNK_SIZE_Z) + 0.5D) - blockZ) / width;
+                    int yIndex = maxY;
+                    boolean replaceTopBlock = false;
+                    if (xPercentage * xPercentage + zPercentage * zPercentage < 1.0D) {
+                        for (int y = maxY - 1; y >= minY; y--) {
+                            double yPercentage = ((y + 0.5D) - blockY) / height;
+                            if (yPercentage > -0.7D && xPercentage * xPercentage + yPercentage * yPercentage + zPercentage * zPercentage < 1.0D) {
+                                int blockId = result.getBlock(x, yIndex, z);
+                                if (Blocks.hasTag(blockId, BlockTags.CAVE_GEN_REPLACES_SURFACE)) {
+                                    replaceTopBlock = true;
+                                }
+                                if (blockId == Blocks.STONE.id() || blockId == Blocks.DIRT.id() || blockId == Blocks.GRASS.id()) {
+                                    if (y < 10) {
+                                        result.setBlock(x, yIndex, z, Blocks.FLUID_LAVA_STILL.id());
+                                    } else {
+                                        result.setBlock(x, yIndex, z, 0);
+
+                                        if (replaceTopBlock) {
+                                            Biome biome = worldObj.getBlockBiome(x, yIndex - 1, z);
+                                            int topBlockId = biome.topBlock;
+                                            int fillBlockId = biome.fillerBlock;
+                                            int id = result.getBlock(x, yIndex - 1, z);
+                                            if (id == fillBlockId) {
+                                                result.setBlock(x, yIndex - 1, z, topBlockId);
+                                            }
+                                        }
+                                    }
+                                }
+                            }
+
+                            yIndex--;
+                        }
+                    }
+                }
+            }
+
+            if (noBranches) {
+                break;
+            }
+        }
+    }
+
+    @Override
+    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result) {
+        int cavesToGenerate = rand.nextInt(rand.nextInt(rand.nextInt(40) + 1) + 1);
+        if (this.rand.nextInt(15) != 0) {
+            cavesToGenerate = 0;
+        }
+
+        final int yRange = maxY - minY;
+
+        for (int i = 0; i < cavesToGenerate; i++) {
+            double blockX = chunkX * Chunk.CHUNK_SIZE_X + this.rand.nextInt(Chunk.CHUNK_SIZE_X);
+            double blockY = minY + this.rand.nextInt(this.rand.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
+            double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + this.rand.nextInt(Chunk.CHUNK_SIZE_Z);
+
+            int numBranches = 1;
+            if (rand.nextInt(4) == 0) {
+                generateHubRoom(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ);
+                numBranches += rand.nextInt(4);
+            }
+            for (int l1 = 0; l1 < numBranches; l1++) {
+                float yRot = this.rand.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
+                float xRot = ((this.rand.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
+                float initialRadius = this.rand.nextFloat() * 2.0F + this.rand.nextFloat(); // 0 - 3
+                generateCave(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/ChunkGeneratorParadise.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/ChunkGeneratorDrift.java
similarity index 66%
rename from game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/ChunkGeneratorParadise.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/ChunkGeneratorDrift.java
index ec6e5c2b8..aaf56a65f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/ChunkGeneratorParadise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/ChunkGeneratorDrift.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.world.generate.chunk.perlin.paradise;
+package net.minecraft.core.world.generate.chunk.perlin.drift;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.CavesLargeFeature;
@@ -7,11 +7,11 @@ import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.ChunkDecoratorOverworld;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
 
-public class ChunkGeneratorParadise
+public class ChunkGeneratorDrift
     extends ChunkGeneratorPerlin
 {
-    public ChunkGeneratorParadise(World world)
+    public ChunkGeneratorDrift(World world)
     {
-        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorParadise(world), new SurfaceGeneratorOverworld(world), new LargeFeature[] { new CavesLargeFeature() });
+        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorDrift(world), new SurfaceGeneratorOverworld(world), new LargeFeature[] { new CavesLargeFeature() });
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/DensityGeneratorParadise.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
similarity index 97%
rename from game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/DensityGeneratorParadise.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
index 99e5c9882..8e3b726d9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/DensityGeneratorParadise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
@@ -1,11 +1,11 @@
-package net.minecraft.core.world.generate.chunk.perlin.paradise;
+package net.minecraft.core.world.generate.chunk.perlin.drift;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.noise.PerlinNoise;
 
-public class DensityGeneratorParadise
+public class DensityGeneratorDrift
     implements DensityGenerator
 {
     private final World world;
@@ -16,7 +16,7 @@ public class DensityGeneratorParadise
 //    private final PerlinNoise scaleNoise;
 //    private final PerlinNoise depthNoise;
 
-    public DensityGeneratorParadise(World world)
+    public DensityGeneratorDrift(World world)
     {
         this.world = world;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/TerrainGeneratorDrift.java
similarity index 77%
rename from game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/TerrainGeneratorDrift.java
index 79f38ccdd..ae40b5199 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/TerrainGeneratorParadise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/TerrainGeneratorDrift.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.world.generate.chunk.perlin.paradise;
+package net.minecraft.core.world.generate.chunk.perlin.drift;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -6,16 +6,16 @@ import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
 import net.minecraft.core.world.type.WorldType;
 
-public class TerrainGeneratorParadise
+public class TerrainGeneratorDrift
     extends TerrainGeneratorLerp
 {
     private final DensityGenerator densityGenerator;
 
-    public TerrainGeneratorParadise(World world)
+    public TerrainGeneratorDrift(World world)
     {
         super(world);
 
-        this.densityGenerator = new DensityGeneratorParadise(world);
+        this.densityGenerator = new DensityGeneratorDrift(world);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
index 533a57c14..087267360 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
@@ -17,9 +17,9 @@ public class ChunkGeneratorNether
             new SurfaceGeneratorNether(world),
             new LargeFeature[]
                 {
-                    new CavesLargeFeature(128, 256),
+                    new CavesLargeFeature(64, 256),
                     new WarrensCavesLargeFeature(0, 128),
-                    new NetherBonesLargeFeature(128, 256)
+                    new NetherBonesLargeFeature(64, 256)
                 }
         );
     }
